searchData={"items":[{"type":"module","title":"Storyblok","doc":"Documentation for `Storyblok`.","ref":"Storyblok.html"},{"type":"function","title":"Storyblok.request/2","doc":"","ref":"Storyblok.html#request/2"},{"type":"behaviour","title":"Storyblok.Cache","doc":"This callback must be implemented to utilize caching.\n\nImplement `c:fetch/2` and `c:set/4` and add the following to your config.\n\n```elixir\nconfig :storyblok, cache: true, cache_store: MyApp.CacheStore\n```","ref":"Storyblok.Cache.html"},{"type":"callback","title":"Storyblok.Cache.fetch/2","doc":"Callback for getting data for key from cache store/","ref":"Storyblok.Cache.html#c:fetch/2"},{"type":"callback","title":"Storyblok.Cache.set/4","doc":"Callback for setting data with the given key. expire_in_ms is the TTL for the key in milliseconds.","ref":"Storyblok.Cache.html#c:set/4"},{"type":"type","title":"Storyblok.Cache.json/0","doc":"Valid JSON","ref":"Storyblok.Cache.html#t:json/0"},{"type":"behaviour","title":"Storyblok.Client","doc":"","ref":"Storyblok.Client.html"},{"type":"function","title":"Storyblok.Client.execute/3","doc":"","ref":"Storyblok.Client.html#execute/3"},{"type":"callback","title":"Storyblok.Client.execute/3","doc":"","ref":"Storyblok.Client.html#c:execute/3"},{"type":"module","title":"Storyblok.Datasource","doc":"","ref":"Storyblok.Datasource.html"},{"type":"function","title":"Storyblok.Datasource.entries/1","doc":"","ref":"Storyblok.Datasource.html#entries/1"},{"type":"function","title":"Storyblok.Datasource.list/1","doc":"","ref":"Storyblok.Datasource.html#list/1"},{"type":"module","title":"Storyblok.Link","doc":"","ref":"Storyblok.Link.html"},{"type":"function","title":"Storyblok.Link.list/1","doc":"","ref":"Storyblok.Link.html#list/1"},{"type":"module","title":"Storyblok.Operation","doc":"","ref":"Storyblok.Operation.html"},{"type":"function","title":"Storyblok.Operation.cache?/1","doc":"","ref":"Storyblok.Operation.html#cache?/1"},{"type":"function","title":"Storyblok.Operation.new/2","doc":"","ref":"Storyblok.Operation.html#new/2"},{"type":"function","title":"Storyblok.Operation.put_token/2","doc":"","ref":"Storyblok.Operation.html#put_token/2"},{"type":"function","title":"Storyblok.Operation.query/1","doc":"","ref":"Storyblok.Operation.html#query/1"},{"type":"function","title":"Storyblok.Operation.query_encode/2","doc":"","ref":"Storyblok.Operation.html#query_encode/2"},{"type":"function","title":"Storyblok.Operation.url/1","doc":"","ref":"Storyblok.Operation.html#url/1"},{"type":"module","title":"Storyblok.ReqClient","doc":"","ref":"Storyblok.ReqClient.html"},{"type":"module","title":"Storyblok.Space","doc":"","ref":"Storyblok.Space.html"},{"type":"function","title":"Storyblok.Space.current/0","doc":"","ref":"Storyblok.Space.html#current/0"},{"type":"module","title":"Storyblok.Story","doc":"","ref":"Storyblok.Story.html"},{"type":"function","title":"Storyblok.Story.get/2","doc":"","ref":"Storyblok.Story.html#get/2"},{"type":"function","title":"Storyblok.Story.list/1","doc":"","ref":"Storyblok.Story.html#list/1"},{"type":"module","title":"Storyblok.Tag","doc":"","ref":"Storyblok.Tag.html"},{"type":"function","title":"Storyblok.Tag.list/1","doc":"","ref":"Storyblok.Tag.html#list/1"},{"type":"extras","title":"Storyblok","doc":"# Storyblok","ref":"readme.html"},{"type":"extras","title":"Installation - Storyblok","doc":"The [package](https://hex.pm/packages/storyblok) can be installed by adding `storyblok` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:storyblok, \"~> 2023.12.24-beta.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Storyblok","doc":"#","ref":"readme.html#configuration"},{"type":"extras","title":"Storyblok API Token - Storyblok","doc":"The Storyblok `token` can be configured 2 ways.\n\n##","ref":"readme.html#storyblok-api-token"},{"type":"extras","title":"Application - Storyblok","doc":"To configure the `token` for your entire application, add the following to your config file.\n\n```elixir\nimport Config\n\nconfig :storyblok, token: \" \"\n```\n\n##","ref":"readme.html#application"},{"type":"extras","title":"Per Request - Storyblok","doc":"Alternatively, the `token` can be configured per request by passing `token` to `Storyblok.request`.\n\n```elixir\n\"123\"\n|> Storyblok.Story.get()\n|> Storyblok.request(token: \" \")\n```","ref":"readme.html#per-request"},{"type":"extras","title":"Caching - Storyblok","doc":"The default configuration is to disable caching, every request hits the Storyblok API.\n\nCaching can be enabled by setting the follow configs.\n\n```elixir\nimport Config\n\nconfig :storyblok, cache: true, cache_store: MyApp.CacheModule\n```\n\nAny store can be used for caching (Redis, MemCached, etc), your application must implement the `Storyblok.Cache` behaviour.\n\n```elixir\ndefmodule MyApp.CacheModule do\n  def fetch(key, opts) do\n    case MyApp.get(key, opts) do\n      {:ok, data} -> {:ok, data}\n      {:error, _reason} -> {:error, :not_found}\n    end\n  end\n\n  def set(key, value, expire_in_ms, opts) do\n    case MyApp.set(key, value, expire_in_ms, opts) do\n      {:ok, _data} -> :ok\n      {:error, reason} -> {:error, reason}\n    end\n  end\nend\n```","ref":"readme.html#caching"}],"content_type":"text/markdown"}